/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.c,v 1.3 2008/05/26 09:06:20 myasuma Exp $
 */

/*
 *		ꥢI/OǥХSIO˥ɥ饤СFSMPB for NiosII UARTѡ
 */

#include <kernel.h>
#include "fsmpb.h"
#include "target_serial.h"
#include "nios2_gcc/prc_insn.h"


#ifdef NIOS2_HAL


/*
 * UART  ʰץɥ饤
 */

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {{}};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB  siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((UINT)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))

#ifdef USE_JTAG_UART
/*
 *  JTAG_UART ϥơȥǡƱ˼뤿ᡤơ
 *  åȥǡɤ߹ǤޤΤᡤuart_getready()
 *  ¹ԤΥǡ롥  
 *  JTAG_UARTǡե饰jtag_uart_read-1:̤1:
 */ 
uint8_t jtag_uart_buf = 0;
int8_t jtag_uart_read = -1;
#endif /* USE_JTAG_UART */

/*
 * ʸ?
 */
Inline bool_t
uart_getready(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
    return((IORD_ALTERA_AVALON_UART_STATUS(UART_BASE) & ALTERA_AVALON_UART_STATUS_RRDY_MSK) != 0);
#else
    UW tmp = IORD_ALTERA_AVALON_JTAG_UART_DATA(JTAG_UART_BASE);
    jtag_uart_buf = (uint8_t)tmp;
    jtag_uart_read = 1;				/* JTAG_UARTǡե饰jtag_uart_read-1:̤1: */
    return ((tmp & ALTERA_AVALON_JTAG_UART_DATA_RVALID_MSK) != 0);
#endif /* USE_JTAG_UART	*/	
}

/*
 * ʸǤ뤫?
 */
Inline bool_t
uart_putready(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
    return((IORD_ALTERA_AVALON_UART_STATUS(UART_BASE) & ALTERA_AVALON_UART_STATUS_TRDY_MSK) != 0);
#else
    return((IORD_ALTERA_AVALON_JTAG_UART_CONTROL(
        JTAG_UART_BASE) & ALTERA_AVALON_JTAG_UART_CONTROL_WSPACE_MSK) > 0);
#endif /* USE_JTAG_UART	*/
}

/*
 *  ʸμФ
 */
Inline uint8_t
uart_getchar(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
    return((uint8_t)(IORD_ALTERA_AVALON_UART_RXDATA(UART_BASE)));
#else
    return((uint8_t)(IORD_ALTERA_AVALON_JTAG_UART_DATA(JTAG_UART_BASE)));
#endif /* USE_JTAG_UART	*/
}

/*
 *  ʸν񤭹
 */
Inline void
uart_putchar(SIOPCB *siopcb, uint8_t c)
{
#ifndef USE_JTAG_UART
    IOWR_ALTERA_AVALON_UART_TXDATA(UART_BASE, c);
#else
    IOWR_ALTERA_AVALON_JTAG_UART_DATA(JTAG_UART_BASE, c);
#endif /* USE_JTAG_UART */
}

/*
 * ؿ
 */
/*
 *  ߵ
 */
Inline void
uart_enable_send(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
    IOWR_ALTERA_AVALON_UART_CONTROL(UART_BASE,
        IORD_ALTERA_AVALON_UART_CONTROL(UART_BASE) | ALTERA_AVALON_UART_CONTROL_TRDY_MSK);
#else
    IOWR_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE,
        IORD_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE) | ALTERA_AVALON_JTAG_UART_CONTROL_WE_MSK);
#endif /* USE_JTAG_UART */
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_send(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
    IOWR_ALTERA_AVALON_UART_CONTROL(UART_BASE,
        IORD_ALTERA_AVALON_UART_CONTROL(UART_BASE) & ~ALTERA_AVALON_UART_CONTROL_TRDY_MSK);
#else
    IOWR_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE,
        IORD_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE) & ~ALTERA_AVALON_JTAG_UART_CONTROL_WE_MSK);
#endif /* USE_JTAG_UART */
}

/*
 * ؿ
 */
/*
 *  ߵ
 */
Inline void
uart_enable_rcv(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
    IOWR_ALTERA_AVALON_UART_CONTROL(UART_BASE,
        IORD_ALTERA_AVALON_UART_CONTROL(UART_BASE) | ALTERA_AVALON_UART_STATUS_RRDY_MSK);
#else
    IOWR_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE,
        IORD_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE) | ALTERA_AVALON_JTAG_UART_CONTROL_RE_MSK);
#endif /* USE_JTAG_UART	*/
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_rcv(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART	
    IOWR_ALTERA_AVALON_UART_CONTROL(UART_BASE,
        IORD_ALTERA_AVALON_UART_CONTROL(UART_BASE) & ~ALTERA_AVALON_UART_STATUS_RRDY_MSK);
#else
    IOWR_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE,
        IORD_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE) & ~ALTERA_AVALON_JTAG_UART_CONTROL_RE_MSK);
#endif /* USE_JTAG_UART	*/	
}


/*
 *  SIOɥ饤Фν롼
 *  1ݡȤʤᡤޤ̣Ϥʤ	
 */
void
uart_initialize(intptr_t exinf)
{
    SIOPCB  *siopcb;
    uint32_t    i;

    /*
     *  ꥢI/Oݡȴ֥åν
     */
    for (siopcb = siopcb_table, i = 0; i < TNUM_SIOP; siopcb++, i++) {
        siopcb->siopinib = &(siopinib_table[i]);
        siopcb->openflag = false;
        siopcb->sendflag = false;
    }
}


/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
uart_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB  *siopcb;
    const SIOPINIB  *siopinib;

    siopcb = get_siopcb(siopid);
    siopinib = siopcb->siopinib;

#ifndef USE_JTAG_UART
    IOWR_ALTERA_AVALON_UART_STATUS(UART_BASE, 0x00);

    /*
     *  ߵ
     */
    IOWR_ALTERA_AVALON_UART_CONTROL(UART_BASE, ALTERA_AVALON_UART_STATUS_RRDY_MSK);
#else
    IOWR_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE, ALTERA_AVALON_JTAG_UART_CONTROL_RE_MSK);
#endif /* USE_JTAG_UART */

    siopcb->exinf = exinf;
    siopcb->getready = siopcb->putready = false;
    siopcb->openflag = true;

    /*
     * ߥȥγߵ
     */
    ena_int(INTNO_SIO);

    return(siopcb);
}


/*
 * ꥢI/OݡȤνλ
 */
void
uart_cls_por(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
    /* ߶ػ */
    IOWR_ALTERA_AVALON_UART_CONTROL(UART_BASE, 0x00);
#else
    /* ߶ػ */
    IOWR_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE, 0x00);
#endif /* USE_JTAG_UART */
    siopcb->openflag = false;
    siopcb->sendflag = false;

    /*
     * ߤζػ
     */
    dis_int(INTNO_SIO);
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
uart_snd_chr(SIOPCB *siopcb, char_t chr)
{
    if(uart_putready(siopcb)){
        uart_putchar(siopcb, (uint8_t) chr);
        return(true);
    }
    return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int32_t
uart_rcv_chr(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
	if (uart_getready(siopcb)) {
		return((int32_t)(uint8_t) uart_getchar(siopcb));
	}
	return(-1);
#else
	uint8_t tmp;
	
	if (jtag_uart_read != -1) {
		tmp = jtag_uart_buf;
		jtag_uart_buf = 0;
		jtag_uart_read = -1;		/* JTAG_UARTǡե饰jtag_uart_read-1:̤1: */
		return tmp;
	}
	return(-1);
#endif /* USE_JTAG_UART	*/	
}


/*
 *  ꥢI/OݡȤΥХåε
 */
void
uart_ena_cbr(SIOPCB *siopcb, uint32_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        uart_enable_send(siopcb);
        break;
      case SIO_RDY_RCV:
        uart_enable_rcv(siopcb);
        break;
    }

}


/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
uart_dis_cbr(SIOPCB *siopcb, uint32_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        uart_disable_send(siopcb);
        break;
      case SIO_RDY_RCV:
        uart_disable_rcv(siopcb);
        break;
    }
}


/*
 *  ꥢI/OݡȤФ߽
 */
static void
uart_isr_siop(SIOPCB *siopcb)
{
    if (uart_getready(siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        uart_irdy_rcv(siopcb->exinf);
    }

    if (uart_putready(siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        uart_irdy_snd(siopcb->exinf);
    }
}


/*
 *  SIOγߥӥ롼
 */
void
uart_isr(intptr_t exinf)
{
    if (siopcb_table[0].openflag) {
        uart_isr_siop(&(siopcb_table[0]));
    }
}


#else  /* NIOS2_HAL */


/*
 * UART  ʰץɥ饤
 */

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {{}};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB  siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((UINT)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))

#ifdef USE_JTAG_UART
/*
 *  JTAG_UART ϥơȥǡƱ˼뤿ᡤơ
 *  åȥǡɤ߹ǤޤΤᡤuart_getready()
 *  ¹ԤΥǡ롥  
 */ 
uint8_t jtag_uart_buf = -1;
#endif /* USE_JTAG_UART */

/*
 * ʸ?
 */
Inline bool_t
uart_getready(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
	return((sil_rew_mem((void*)UART_STATUS) &
			UART_STATUS_RRDY) != 0);
#else
	UW tmp = sil_rew_mem((void*)JTAG_UART_DATA);
	jtag_uart_buf = (uint8_t)tmp;	
	return ((tmp & JTAG_UART_DATA_RVALID) != 0);
#endif /* USE_JTAG_UART	*/	
}

/*
 * ʸǤ뤫?
 */
Inline bool_t
uart_putready(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
	return((sil_rew_mem((void*)UART_STATUS) & UART_STATUS_TRDY) != 0);
#else
	return((sil_rew_mem(
		(void*)JTAG_UART_CONTROL) & JTAG_UART_CONTROL_WSAPCE) > 0);
#endif /* USE_JTAG_UART	*/
}

/*
 *  ʸμФ
 */
Inline uint8_t
uart_getchar(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
	return((uint8_t)(sil_rew_mem((void*)UART_RXDATA)));
#else
	return((uint8_t)(sil_rew_mem((void*)JTAG_UART_DATA)));
#endif /* USE_JTAG_UART	*/
}

/*
 *  ʸν񤭹
 */
Inline void
uart_putchar(SIOPCB *siopcb, uint8_t c)
{
#ifndef USE_JTAG_UART
	sil_wrw_mem((void*)UART_TXDATA, c);
#else
	sil_wrw_mem((void*)JTAG_UART_DATA,c);
#endif /* USE_JTAG_UART	*/
}

/*
 * ؿ
 */
/*
 *  ߵ
 */
Inline void
uart_enable_send(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
	sil_wrw_mem((void*)UART_CONTROL,
				sil_rew_mem((void*)UART_CONTROL)|UART_CONTROL_ITRD);
#else
	sil_wrw_mem((void*)JTAG_UART_CONTROL,
				sil_rew_mem((void*)JTAG_UART_CONTROL)|JTAG_UART_CONTROL_WIE);
#endif /* USE_JTAG_UART	*/	
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_send(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
	sil_wrw_mem((void*)UART_CONTROL,
				sil_rew_mem((VP)UART_CONTROL)&~UART_CONTROL_ITRD);
#else
	sil_wrw_mem((void*)JTAG_UART_CONTROL,
				sil_rew_mem((void*)JTAG_UART_CONTROL)&~JTAG_UART_CONTROL_WIE);
#endif /* USE_JTAG_UART	*/
}

/*
 * ؿ
 */
/*
 *  ߵ
 */
Inline void
uart_enable_rcv(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
	sil_wrw_mem((void*)UART_CONTROL,
				sil_rew_mem((void*)UART_CONTROL)|UART_STATUS_RRDY);
#else
	sil_wrw_mem((void*)JTAG_UART_CONTROL,
				sil_rew_mem((void*)JTAG_UART_CONTROL)|JTAG_UART_CONTROL_RIE);
#endif /* USE_JTAG_UART	*/
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_rcv(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART	
	sil_wrw_mem((void*)UART_CONTROL,
				sil_rew_mem((void*)UART_CONTROL)&~UART_STATUS_RRDY);
#else
	sil_wrw_mem((void*)JTAG_UART_CONTROL,
				sil_rew_mem((void*)JTAG_UART_CONTROL)&~JTAG_UART_CONTROL_RIE);
#endif /* USE_JTAG_UART	*/	
}


/*
 *  SIOɥ饤Фν롼
 *  1ݡȤʤᡤޤ̣Ϥʤ
 */
void
uart_initialize(intptr_t exinf)
{
    SIOPCB  *siopcb;
    uint32_t    i;

    /*
     *  ꥢI/Oݡȴ֥åν
     */
    for (siopcb = siopcb_table, i = 0; i < TNUM_SIOP; siopcb++, i++) {
        siopcb->siopinib = &(siopinib_table[i]);
        siopcb->openflag = false;
        siopcb->sendflag = false;
    }
}


/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
uart_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB  *siopcb;
    const SIOPINIB  *siopinib;

    siopcb = get_siopcb(siopid);
    siopinib = siopcb->siopinib;

#ifndef USE_JTAG_UART		
//    sil_wrw_mem(UART_DIVISOR, UART_DIVISOR_VAL);
    sil_wrw_mem((void*)UART_STATUS, 0x00);
    
    /*
     *  ߵ
     */
    sil_wrw_mem((void*)UART_CONTROL, UART_STATUS_RRDY);
#else
	sil_wrw_mem((void*)JTAG_UART_CONTROL,JTAG_UART_CONTROL_RIE);
#endif /* USE_JTAG_UART	*/
	
    siopcb->exinf = exinf;
    siopcb->getready = siopcb->putready = false;
    siopcb->openflag = true;

    /*
     * ߥȥγߵ
     */
    ena_int(INTNO_SIO);

    return(siopcb);
}


/*
 * ꥢI/OݡȤνλ
 */
void
uart_cls_por(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART	
    /* ߶ػ */
    sil_wrw_mem((void*)UART_CONTROL, 0x00);
#else
	sil_wrw_mem((void*)JTAG_UART_CONTROL,0x00);
#endif /* USE_JTAG_UART	*/		
    siopcb->openflag = false;
    siopcb->sendflag = false;
  
    /*
     * ߤζػ
     */
    dis_int(INTNO_SIO);
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
uart_snd_chr(SIOPCB *siopcb, char_t chr)
{
    if(uart_putready(siopcb)){
        uart_putchar(siopcb, (uint8_t) chr);
        return(true);
    }
    return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int32_t
uart_rcv_chr(SIOPCB *siopcb)
{
#ifndef USE_JTAG_UART
	if (uart_getready(siopcb)) {
		return((int32_t)(uint8_t) uart_getchar(siopcb));
	}
	return(-1);
#else
	uint8_t tmp;
	
	if (jtag_uart_buf != -1) {
		tmp = jtag_uart_buf;
		jtag_uart_buf = -1;
		return tmp;
	}
	return(-1);
#endif /* USE_JTAG_UART	*/	
}


/*
 *  ꥢI/OݡȤΥХåε
 */
void
uart_ena_cbr(SIOPCB *siopcb, uint32_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        uart_enable_send(siopcb);
        break;
      case SIO_RDY_RCV:
        uart_enable_rcv(siopcb);
        break;
    }

}


/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
uart_dis_cbr(SIOPCB *siopcb, uint32_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        uart_disable_send(siopcb);
        break;
      case SIO_RDY_RCV:
        uart_disable_rcv(siopcb);
        break;
    }
}


/*
 *  ꥢI/OݡȤФ߽
 */
static void
uart_isr_siop(SIOPCB *siopcb)
{
    if (uart_getready(siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        uart_irdy_rcv(siopcb->exinf);
    }

    if (uart_putready(siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        uart_irdy_snd(siopcb->exinf);
    }
}


/*
 *  SIOγߥӥ롼
 */
void
uart_isr(intptr_t exinf)
{
    if (siopcb_table[0].openflag) {
        uart_isr_siop(&(siopcb_table[0]));
    }
}

#endif /* NIOS2_HAL */
