/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.h,v 1.3 2008/05/26 09:06:20 myasuma Exp $
 */

/*
 * UARTǥХFSMPB for NiosIIѡ
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H


#ifdef NIOS2_HAL

#ifndef TOPPERS_MACRO_ONLY
#include "altera_avalon_uart/inc/altera_avalon_uart_regs.h"
#include "altera_avalon_jtag_uart/inc/altera_avalon_jtag_uart_regs.h"
#endif /* TOPPERS_MACRO_ONLY */

#endif /* NIOS2_HAL */


/*
 *  ꥢI/Oγߥϥɥγֹ
 */
#define INHNO_SIO       UART_INTLVL     /* ߥϥɥֹ */
#define INTNO_SIO       UART_INTLVL     /* ֹ */
#define INTPRI_SIO      UART_INTLVL     /* ͥ */
#define INTATR_SIO      TA_NULL         /* ° */

/*
 *  Хå롼μֹ
 *  OPB_UARTLITE ϡߤʬƤʤᡤ̣Ϥʤ
 */
#define SIO_RDY_SND    1u              /* ǽХå */
#define SIO_RDY_RCV    2u              /* ΥХå */


/*
 * ¢UART ʰSIOɥ饤
 */

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {

} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block {
    const SIOPINIB  *siopinib;  /* ꥢI/OݡȽ֥å */
    intptr_t        exinf;      /* ĥ */
    bool_t    openflag;           /* ץѤߥե饰 */
    bool_t    sendflag;           /* ߥ֥͡ե饰 */
    bool_t    getready;           /* ʸ */
    bool_t    putready;           /* ʸǤ */
} SIOPCB;

extern SIOPCB   siopcb_table[];


#ifdef NIOS2_HAL

Inline void
uart_putc(unsigned char c){
#ifndef USE_JTAG_UART
    while(!(IORD_ALTERA_AVALON_UART_STATUS(UART_BASE) & ALTERA_AVALON_UART_STATUS_TRDY_MSK));
    IOWR_ALTERA_AVALON_UART_TXDATA(UART_BASE, c);
#else
    /* ߥʥ뤬³ACӥåȤ0ˤξ硢饯DATA쥸ؤΥ饤ȤϹԤʤ */
    if((IORD_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE) & ALTERA_AVALON_JTAG_UART_CONTROL_AC_MSK) > 0) {
        while(!((IORD_ALTERA_AVALON_JTAG_UART_CONTROL(JTAG_UART_BASE) & ALTERA_AVALON_JTAG_UART_CONTROL_WSPACE_MSK) > 0));
        IOWR_ALTERA_AVALON_JTAG_UART_DATA(JTAG_UART_BASE, c);
    }
#endif /* USE_JTAG_UART	*/
}

Inline unsigned char
uart_getc(void){
#ifndef USE_JTAG_UART
    while(!(IORD_ALTERA_AVALON_UART_STATUS(UART_BASE) & ALTERA_AVALON_UART_STATUS_RRDY_MSK));
    return (char)(IORD_ALTERA_AVALON_UART_RXDATA(UART_BASE));
#else
    int tmp;
    do{
        tmp = IORD_ALTERA_AVALON_JTAG_UART_DATA(JTAG_UART_BASE);
    }while((tmp & ALTERA_AVALON_JTAG_UART_DATA_RVALID_MSK) == 0);

    return (char)tmp;
#endif /* USE_JTAG_UART	*/
}

#else  /* NIOS2_HAL */


#define uart_openflag   (siopcb_table[0].openflag)

Inline void
uart_putc(unsigned char c){
#ifndef USE_JTAG_UART
    while(!(sil_rew_mem((void*)UART_STATUS) & UART_STATUS_TRDY));
    sil_wrw_mem((void*)UART_TXDATA, c);
#else
    while(!((sil_rew_mem((void*)JTAG_UART_CONTROL) & JTAG_UART_CONTROL_WSAPCE) > 0));
    sil_wrw_mem((void*)JTAG_UART_DATA, c);
#endif /* USE_JTAG_UART	*/
}

Inline unsigned char
uart_getc(void){
#ifndef USE_JTAG_UART
    while(!(sil_rew_mem((void*)UART_STATUS) & UART_STATUS_RRDY));
    return (char)(sil_rew_mem((void*)UART_RXDATA));
#else
    int tmp;
    do{
        tmp = sil_rew_mem((void*)JTAG_UART_DATA);
    }while((tmp &JTAG_UART_DATA_RVALID) == 0);

    return (char)tmp;
#endif /* USE_JTAG_UART	*/
}

#endif /* NIOS2_HAL */


/*
 *  SIOɥ饤Фν롼
 */
#define sio_initialize  uart_initialize
extern void uart_initialize(intptr_t exinf);

/* 
 * ꥢI/OݡȤΥץ
 */
#define sio_opn_por uart_opn_por
extern SIOPCB   *uart_opn_por(ID siopid, intptr_t exinf);

/*
 * ꥢI/OݡȤνλ
 */
#define sio_cls_por uart_cls_por
extern void uart_cls_por(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤؤʸ
 */
#define sio_snd_chr uart_snd_chr
extern bool_t uart_snd_chr(SIOPCB *siopcb, char_t chr);

/*
 *  ꥢI/OݡȤʸ
 */
#define sio_rcv_chr uart_rcv_chr
extern int32_t  uart_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
#define sio_ena_cbr uart_ena_cbr
extern void uart_ena_cbr(SIOPCB *siopcb, uint32_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
#define sio_dis_cbr uart_dis_cbr
extern void uart_dis_cbr(SIOPCB *siopcb, uint32_t cbrtn);

/*
 *  ꥢI/OݡȤǽХå
 */
#define sio_irdy_snd   uart_irdy_snd
extern void uart_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
#define sio_irdy_rcv   uart_irdy_rcv
extern void uart_irdy_rcv(intptr_t exinf);

/*
 *  SIOγߥϥɥ
 */
#define sio_isr uart_isr
extern void uart_isr(intptr_t exinf);

#ifndef TOPPERS_MACRO_ONLY


#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_SERIAL_H */
