/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  FSTOPPERS
 *  Copyright (C) 2008 by FUJISOFT INCORPORATED, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_timer.c,v 1.3 2008/05/26 09:06:21 myasuma Exp $
 */

/*
 *		ޥɥ饤СFSMPB for NiosIIѡ
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "fsmpb.h"
#include "target_timer.h"


#ifdef NIOS2_HAL

/*
 * ޤν (6-13-2-1)
 *
 * ޤ޳ߤŪȯؿ
 */ 
void
nios2_timer_initialize(intptr_t exinf)				/* (6-13-2-1) */
{

    /*
     * ޤνϡHALΥǥХ(alt_sys_init)ˤƹԤ
     */

    /*
     * ߥ쥸(ienable)ϡCFG_INT°ǳߵĤѤߡ
     */
}

/*
 *  ޤνλ (6-13-2-2)
 *
 *  ޤưߤ޳ߤȯʤ褦ˤؿ
 */
void
nios2_timer_terminate(intptr_t exinf)
{
    /*  */
    IOWR_ALTERA_AVALON_TIMER_CONTROL(SYS_CLK_TIMER_BASE, ALTERA_AVALON_TIMER_CONTROL_STOP_MSK);

    /* ׵Υꥢ */
    IOWR_ALTERA_AVALON_TIMER_STATUS(SYS_CLK_TIMER_BASE, 0x00);
}

/*
 *  ޳׵Υꥢ
 */
void
nios2_timer_int_clear()
{
    /* TOӥåȤΥꥢ */
    IOWR_ALTERA_AVALON_TIMER_STATUS(SYS_CLK_TIMER_BASE, 0x00);
}

/*
 *   ޤθͤɤ߽Ф
 */
CLOCK
target_timer_get_current(void)
{
    CLOCK count;

    /* ʥåץ쥸˽񤭹ͤۡɤ */
    IOWR_ALTERA_AVALON_TIMER_SNAPL(SYS_CLK_TIMER_BASE, 0x00);

    /* ͤɤ߹ */
    count = IORD_ALTERA_AVALON_TIMER_SNAPL(SYS_CLK_TIMER_BASE);
    count |= IORD_ALTERA_AVALON_TIMER_SNAPH(SYS_CLK_TIMER_BASE) << 16; 


    return(TIMER_CLOCK - count);
}

/*
 *   ߤȯƤ뤫Ƚ
 */
bool_t
nios2_timer_fetch_interrupt(void)
{
    return(IORD_ALTERA_AVALON_TIMER_STATUS(SYS_CLK_TIMER_BASE) & ALTERA_AVALON_TIMER_STATUS_TO_MSK);
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
	target_timer_int_clear();		/* ޳׵Υꥢ */
	signal_time();					/* ƥåζ */
}


#else  /* NIOS2_HAL */


/*
 * ޤν (6-13-2-1)
 *
 * ޤ޳ߤŪȯؿ
 */ 
void
nios2_timer_initialize(intptr_t exinf)				/* (6-13-2-1) */
{
    CLOCK cyc = TIMER_CLOCK;

    assert(cyc <= MAX_CLOCK);                       /* ޾ͤΥå */

    /* ޡȥå */
    sil_wrw_mem((void*)TIM_CONTROL,TIM_CONTROL_STOP);
    /* ॢȥơꥢ */
    sil_wrw_mem((void*)TIM_STATUS, 0x00);

    sil_wrw_mem((void*)TIM_PERIODL, (cyc & 0xffff)); /* 󥿡å 16bit */
    sil_wrw_mem((void*)TIM_PERIODH, (cyc >> 16));    /* 󥿡å 16bit */

    /*
     * ޡȡȥɡߵ
     */
    sil_wrw_mem((void*)TIM_CONTROL, TIM_CONTROL_START
                                 |TIM_CONTROL_COUNT|TIM_CONTROL_ITO);

    /*
     * ߥ쥸(ienable)ϡCFG_INT°ǳߵĤѤߡ
     */
}

/*
 *  ޤνλ (6-13-2-2)
 *
 *  ޤưߤ޳ߤȯʤ褦ˤؿ
 */
void
nios2_timer_terminate(intptr_t exinf)
{
    /*  */
    sil_wrw_mem((void*)TIM_CONTROL, TIM_CONTROL_STOP);

    /* ׵Υꥢ */
    sil_wrw_mem((void*)TIM_STATUS, 0x00);
}

/*
 *  ޳׵Υꥢ
 */
void
nios2_timer_int_clear()
{
    /* TOӥåȤΥꥢ */
    sil_wrw_mem((void*)TIM_STATUS,0x00);
}

/*
 *   ޤθͤɤ߽Ф
 */
CLOCK
target_timer_get_current(void)
{
    CLOCK count;

    /* ʥåץ쥸˽񤭹ͤۡɤ */
    sil_wrw_mem((void*)TIM_SNAPL, 0x00);

    /* ͤɤ߹ */
    count = sil_rew_mem((void*)TIM_SNAPL);
    count |= sil_rew_mem((void*)TIM_SNAPH) << 16; 

    return(TIMER_CLOCK - count);
}

/*
 *   ߤȯƤ뤫Ƚ
 */
bool_t
nios2_timer_fetch_interrupt(void)
{
    return(sil_rew_mem((void*)TIM_STATUS) & TIM_STATUS_TO);
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
//	i_begin_int(INTNO_TIMER);
	target_timer_int_clear();		/* ޳׵Υꥢ */
	signal_time();					/* ƥåζ */
//	i_end_int(INTNO_TIMER);
}

#endif /* NIOS2_HAL */
